Imports System.Text

Namespace MSDNReceiver
	Public Class SequenceState
		Public Sub New()
			nextSequenceId = 1
			outOfSequenceMessages = New Dictionary(Of Integer, Long)
		End Sub

		Private outOfSequenceMessages As Dictionary(Of Integer, Long)
		Private nextSequenceId As Integer

		Public Function GetNextSequenceId() As Integer
			Return nextSequenceId
		End Function

		Public Sub SetNextSequenceId(ByVal nextMessage As Integer)
			nextSequenceId = nextMessage
			Dim cleanupList As New List(Of Integer)

			For Each msgIdx As KeyValuePair(Of Integer, Long) In outOfSequenceMessages
				If msgIdx.Key < nextMessage Then
					cleanupList.Add(msgIdx.Key)
				End If
			Next msgIdx
			For Each msgIdx As Integer In cleanupList
				outOfSequenceMessages.Remove(msgIdx)
			Next msgIdx
		End Sub

		Public Function GetNextOutOfSequenceMessage() As Long
			Dim nextMessage As Long = -1
			If outOfSequenceMessages.ContainsKey(nextSequenceId) Then
				nextMessage = outOfSequenceMessages(nextSequenceId)
			End If
			Return nextMessage
		End Function

		Public Sub AddOutOfSequenceMessage(ByVal sequenceId As Integer, ByVal internalMessageSequence As Long)
			outOfSequenceMessages.Add(sequenceId, internalMessageSequence)
		End Sub
	End Class
End Namespace
